<?php

/**
 * @file
 * Features hooks implemented by the Editor module.
 */

/**
 * Implements hook_features_pipe_alter().
 *
 * Add modules providing editors associated with text formats as dependencies.
 */
function editor_features_pipe_alter(&$pipe, $data, $export) {
  if ($export['component'] == 'filter') {
    $format_ids = array_values($data);

    foreach ($format_ids as $format_id) {
      $format = filter_format_load($format_id);
      editor_format_ensure_additional_properties($format);

      if ($editor = editor_load($format->editor)) {
        $pipe['dependencies'][$editor['module']] = $editor['module'];
      }
    }
  }
}
