<?php

/**
 * @file
 * Features hooks implemented by the Editor CKEditor module.
 */

/**
 * Implements hook_features_pipe_alter().
 *
 * Add modules providing enabled CKEditor plugins to text format dependencies.
 */
function editor_ckeditor_features_pipe_alter(&$pipe, $data, $export) {
  if ($export['component'] == 'filter') {
    $ckeditor_plugins_module_map = array();
    foreach (module_implements('editor_ckeditor_plugins') as $module) {
      $module_plugins_map = module_invoke($module, 'editor_ckeditor_plugins');
      $ckeditor_plugins = array_keys($module_plugins_map);
      $ckeditor_plugins_module_map += array_fill_keys($ckeditor_plugins, $module);
    }

    $format_ids = array_values($data);
    foreach ($format_ids as $format_id) {
      $format = filter_format_load($format_id);
      editor_format_ensure_additional_properties($format);

      if ($format->editor != 'ckeditor') {
        continue;
      }

      $enabled_plugins = array_keys(editor_ckeditor_get_enabled_plugin_files($format));
      foreach ($enabled_plugins as $plugin) {
        $pipe['dependencies'][$ckeditor_plugins_module_map[$plugin]] = $ckeditor_plugins_module_map[$plugin];
      }
    }
  }
}
